#!/usr/bin/perl

  ### Include the standard library and define local variables.
  require '../guardiandigital-lib.pl';
  &get_miniserv_config(\%miniserv);

  ### Set auto-logout after fifteen minutes.
  delete($miniserv{'logouttime'});
  $miniserv{'logouttime'} = 15;


  ### Print the header and a horizonal rule.
  &header("Configuration Complete", "");


  ### Parse out all of the stuff we want to display.
  $hostname       = `cat /etc/hostname`;
  $resolv_str     = `cat /etc/resolv.conf`;
  $interfaces_str = `cat /etc/network/interfaces`;

  ### Make the allow addresses comma-seperated.
  $allow          = $miniserv{'allow'};
  $allow          =~ s/\s+/, /g;

  &put_miniserv_config(\%miniserv);


  ### Split the resolv and interface files into lines.
  @resolv = split /\n/, $resolv_str;
  @interfaces = split /\n/, $interfaces_str;

  ### Extract the primary and secondary DNS IP's.
  ($primary_dns)   = ($resolv[1] =~ m/^nameserver\ (.*)$/);
  ($secondary_dns) = ($resolv[2] =~ m/^nameserver\ (.*)$/);

  ### Find the address, netmask,and gateway.
  $in_interface = 0;
  foreach $iface (@interfaces) {
    if ($iface =~ m/^iface\ eth0\ inet\ static$/) { $in_interface = 1; }

    if (($iface =~ m/address\ (.*)$/) && $in_interface) { $address = $1; }
    if (($iface =~ m/netmask\ (.*)$/) && $in_interface) { $netmask = $1; }
    if (($iface =~ m/default\ gw\ (.*)$/) && $in_interface) { $gateway = $1; }
  }


  ($named)    = (`/sbin/chkconfig --list named` =~ m/3\:([a-z]+)\s/);
  ($postfix)  = (`/sbin/chkconfig --list postfix` =~ m/3\:([a-z]+)\s/);
  ($httpd)    = (`/sbin/chkconfig --list httpd` =~ m/3\:([a-z]+)\s/);
  ($imapd)    = (`/sbin/chkconfig --list stunnel-imap` =~ m/3\:([a-z]+)\s/);
  ($pop3d)    = (`/sbin/chkconfig --list stunnel-pop3` =~ m/3\:([a-z]+)\s/);
  ($userpass) = (`/sbin/chkconfig --list userpass` =~ m/3\:([a-z]+)\s/);

  if ($named eq "on")      { $named_stat   = "CHECKED"; }
  if ($postfix eq "on")    { $postfix_stat = "CHECKED"; }
  if ($httpd eq "on")      { $httpd_stat   = "CHECKED"; }
  if ($imapd eq "on")      { $imapd_stat   = "CHECKED"; }
  if ($pop3d eq "on")      { $pop3d_stat   = "CHECKED"; }
  if ($userpass eq "on")   { $userpass_stat   = "CHECKED"; }


print <<END;
<P><CENTER><TABLE BORDER=0 WIDTH="500" CELLPADDING=0 CELLSPACING=0>
<TR $tb>
  <TD COLSPAN=2><DIV CLASS="ttitle"><B>Initial Configuration</B></DIV></TD>
</TR>

<TR $cb> <TD COLSPAN=2>&nbsp;</TD> </TR>

<TR $cb>
  <TD WIDTH=20>&nbsp;</TD>
  <TD>
    <TABLE BORDER=0 WIDTH=100% CELLPADDING=0 CELLSPACING=0>

    <TR $tb> <TD COLSPAN="2">
      <DIV CLASS="thead"><B>Configuration Complete!</B></DIV>
    </TD> </TR>

      <TR $cb> <TD COLSPAN="2">&nbsp;</TD> </TR>

      <TR $cb>
        <TD COLSPAN="2"><DIV CLASS="nbody">
          <B>Congratulations!</B> You have successfully configured the Lockbox. 
          After you reboot the Lockbox networking and all services will be
          enabled.

          <P>Below is a summary of your configuration.  You should print this
          out and store it in a safe place.
      </TR>

    <TR $cb><TD COLSPAN="2">&nbsp;</TD></TR>

    <TR $tb> <TD COLSPAN="2">
      <DIV CLASS="thead"><B>Network Configuration</B></DIV>
    </TD> </TR>

      <TR>
        <TD><DIV CLASS=nbody><B>Hostname</B><DIV></TD>
        <TD><DIV CLASS=nbody>$hostname</DIV></TD>
      </TR>

      <TR $cb><TD COLSPAN="2">&nbsp;</TD></TR>

      <TR>
        <TD><DIV CLASS=nbody><B>IP Address</B><DIV></TD>
        <TD><DIV CLASS=nbody>$address</DIV></TD>
      </TR>

      <TR>
        <TD><DIV CLASS=nbody><B>Netmask</B><DIV></TD>
        <TD><DIV CLASS=nbody>$netmask</DIV></TD>
      </TR>

      <TR>
        <TD><DIV CLASS=nbody><B>Gateway</B><DIV></TD>
        <TD><DIV CLASS=nbody>$gateway</DIV></TD>
      </TR>

      <TR $cb><TD COLSPAN="2">&nbsp;</TD></TR>

      <TR>
        <TD><DIV CLASS=nbody><B>Primary DNS</B><DIV></TD>
        <TD><DIV CLASS=nbody>$primary_dns</DIV></TD>
      </TR>

      <TR>
        <TD><DIV CLASS=nbody><B>Secondary DNS</B><DIV></TD>
        <TD><DIV CLASS=nbody>$secondary_dns</DIV></TD>
      </TR>

    <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

    <TR $tb> <TD COLSPAN="2">
      <DIV CLASS="thead"><B>Trusted Hosts</B></DIV>
    </TD> </TR>

      <TR>
        <TD><DIV CLASS=nbody><B>Trusted Hosts</B><DIV></TD>
        <TD><DIV CLASS=nbody>$allow</DIV></TD>
      </TR>

    <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

    <TR $tb> <TD COLSPAN="2">
      <DIV CLASS="thead"><B>Active Services</B></DIV>
    </TD> </TR>
END

  print "      <TR>\n";
  print "        <TD><DIV CLASS=nbody><B>Secure Shell Services</B><DIV></TD>\n";
  print "        <TD><DIV CLASS=nbody><FONT COLOR=GREEN><B>Active</DIV></TD>\n";
  print "      </TR>\n";

  print "      <TR>\n";
  print "        <TD><DIV CLASS=nbody><B>Domain Name Service</B><DIV></TD>\n";
  ($named_stat) ? print "        <TD><DIV CLASS=nbody><FONT COLOR=GREEN><B>", 
                        "Active</DIV></TD>\n"
                : print "        <TD><DIV CLASS=nbody><FONT COLOR=RED><B>", 
                        "Not Active</DIV></TD>\n";
  print "      </TR>\n";

  print "      <TR>\n";
  print "        <TD><DIV CLASS=nbody><B>Mail Server</B><DIV></TD>\n";
  ($postfix_stat) ? print "        <TD><DIV CLASS=nbody><FONT COLOR=GREEN><B>", 
                        "Active</DIV></TD>\n"
                : print "        <TD><DIV CLASS=nbody><FONT COLOR=RED><B>", 
                        "Not Active</DIV></TD>\n";
  print "      </TR>\n";

  print "      <TR>\n";
  print "        <TD><DIV CLASS=nbody><B>Web Server</B><DIV></TD>\n";
  ($httpd_stat) ? print "        <TD><DIV CLASS=nbody><FONT COLOR=GREEN><B>", 
                        "Active</DIV></TD>\n"
                : print "        <TD><DIV CLASS=nbody><FONT COLOR=RED><B>", 
                        "Not Active</DIV></TD>\n";
  print "      </TR>\n";

  print "      <TR>\n";
  print "        <TD><DIV CLASS=nbody><B>IMAP Server</B><DIV></TD>\n";
  ($imapd_stat) ? print "        <TD><DIV CLASS=nbody><FONT COLOR=GREEN><B>", 
                        "Active</DIV></TD>\n"
                : print "        <TD><DIV CLASS=nbody><FONT COLOR=RED><B>", 
                        "Not Active</DIV></TD>\n";
  print "      </TR>\n";

  print "      <TR>\n";
  print "        <TD><DIV CLASS=nbody><B>POP3 Server</B><DIV></TD>\n";
  ($pop3d_stat) ? print "        <TD><DIV CLASS=nbody><FONT COLOR=GREEN><B>", 
                        "Active</DIV></TD>\n"
                : print "        <TD><DIV CLASS=nbody><FONT COLOR=RED><B>", 
                        "Not Active</DIV></TD>\n";
  print "      </TR>\n";

  print "      <TR>\n";
  print "        <TD><DIV CLASS=nbody><B>User Password Changer</B><DIV></TD>\n";
  ($userpass_stat) ? print "        <TD><DIV CLASS=nbody><FONT COLOR=GREEN><B>", 
                        "Active</DIV></TD>\n"
                : print "        <TD><DIV CLASS=nbody><FONT COLOR=RED><B>", 
                        "Not Active</DIV></TD>\n";
  print "      </TR>\n";



print <<FOOTER;

    <TR $cb>
      <TD ALIGN="RIGHT" COLSPAN=2><DIV CLASS=nbody>
        <FORM ACTION="do_reboot.cgi" METHOD="POST">
        <INPUT TYPE="SUBMIT" VALUE="Reboot">
      </TD>
    </TR>
    </TABLE>
  </TD>
<TR>
</TABLE></CENTER><P>
FOOTER

  ### Close up and print the footer.
  &ryanFooter();

