#!/usr/bin/perl

  ### Include the standard library and define local variables.
  require '../guardiandigital-lib.pl';
  &ReadParse();

  ### Get input variables.
  $allow = $in{'allow'};

  $CONF = "/etc/webtool/miniserv.conf";

  @hosts = split(/\s+/, $allow);


  ### Make sure we have input.
  if (!$allow) {
    &PrintError("Please enter at least one trusted hosts.");
    exit;
  }

  foreach $h (@hosts) {
    if ($h =~ /^([0-9\.]+)\/([0-9\.]+)$/) {
      if (!&check_ipaddress($1)) {
        &PrintError("$1 is not a valid network address");
        exit;
      }
      elsif (!&check_ipaddress($2)) {
        &PrintError("$2 is not a valid netmask");
        exit;
      }

      $i = $h;
    }
    elsif ($h =~ /^[0-9\.]+$/) {
      if (!&check_ipaddress($h)) {
        &PrintError("$h is not a complete IP or network address");
        exit;
      }
      $i = $h;
    }
    elsif (!($i = join('.', unpack("CCCC", inet_aton($h))))) {
      &PrintError("Could not find IP address for '$h'");
      exit;
    }

    push(@ip, $i);
  }


  ### Okay, all our data is good to let's commit to the config file.
  &get_miniserv_config(\%miniserv);
    delete($miniserv{"allow"});
    $miniserv{"allow"} = join(' ', @hosts);
  &put_miniserv_config(\%miniserv);


  ### Whisk me away to a magical place...
  &redirect("step6.cgi");
  exit;
