#!/usr/bin/perl

  ### Include the standard library and define local variables.
  require '../guardiandigital-lib.pl';
  &ReadParse();

  if (!$in{'fcn'}) {
    ### Get input variables.
    $user_name  = $in{'user_name'};
    $user_uname = $in{'user_uname'};
    $user_pass1 = $in{'user_pass1'};
    $user_pass2 = $in{'user_pass2'};
    $user_login = $in{'user_login'};

    ### Make sure we have a username.
    if (!$user_name) { 
      &PrintError("Please the users full name.");
      exit;
    }

    ### Make sure we have a username.
    if (!$user_uname) { 
      &PrintError("Please enter a username");
      exit;
    }

    ### Make sure the username is less then eight characters.
    elsif ((length $user_uname) > 8) {
      &PrintError("Username is too long.  Please make it no more then 8 characters.");
      exit;
    }

    ### Make sure the username is alphanumeric.
    elsif ($user_uname =~ m/[^A-Za-z0-9]/) {
      &PrintError("Please enter an alphanumeric username.  Special characters are not allowed");
      exit;
    }

    ### Make sure we have two passwords.
    if (!$user_pass1 || !$user_pass2) {
      &PrintError("Please enter a password");
      exit;
    }

    ### Make sure passwords match.
    elsif ($user_pass1 ne $user_pass2) {
      &PrintError("The two passwords do not match.  Please reenter.");
      exit;
    }

    ### Make sure user does not already exist.
    elsif (`grep $user_uname /etc/passwd`) {
      &PrintError("User already exists.  Please enter a new one");
      exit;
    }



    ### Remove any harmful characters from Real Name.
    $user_name =~ s/\://g;
    $user_name =~ s/\"//g;



    ### Break out all the stuff we want into neater variables.
    $user  = $user_uname; 
    $pass  = &encrypt_password("$user_pass1");
    $name  = $user_name;

    if ($user_login) { $shell = "/bin/bash"; }
    else { $shell = "/bin/false"; }



    ### Get the next UID and GID.
    $change = int(time() / (60*60*24));
    $uid = &GetNextUID();
    $gid = &GetNextGID();



    ### Create the user.
    &create_user($user, $pass, $shell, $name);
  }

  ### Whisk me away to a magical place...
  &redirect("step4.cgi");
  exit;
