#!/usr/bin/perl

  ### Include the standard library and define local variables.
  require '../guardiandigital-lib.pl';
  &ReadParse();

  if (!$in{'fcn'}) {
    ### Get input variables.
    $timezone = $in{'timezone'};

    ### Setup our timezone hash.
    $tz{'East'}->{'name'}       = "/usr/share/zoneinfo/America/New_York";
       $tz{'East'}->{'s1n'}     = "terrapin.csc.ncsu.edu";
       $tz{'East'}->{'s1i'}     = "152.1.58.124";
       $tz{'East'}->{'s2n'}     = "tock.usno.navy.mil";
       $tz{'East'}->{'s2i'}     = "192.5.41.41";
       $tz{'East'}->{'s3n'}     = "bonehed.lcs.mit.edu";
       $tz{'East'}->{'s3i'}     = "18.26.4.105";

    $tz{'Central'}->{'name'}       = "/usr/share/zoneinfo/America/Chicago";
       $tz{'Central'}->{'s1n'}     = "navobs1.wustl.edu";
       $tz{'Central'}->{'s1i'}     = "128.252.19.1";
       $tz{'Central'}->{'s2n'}     = "ntp1.kansas.net";
       $tz{'Central'}->{'s2i'}     = "199.240.130.1";
       $tz{'Central'}->{'s3n'}     = "tock.greyware.com";
       $tz{'Central'}->{'s3i'}     = "207.55.146.54";

    $tz{'Mountain'}->{'name'}       = "/usr/share/zoneinfo/America/Phoenix";
       $tz{'Mountain'}->{'s1n'}     = "usno.pa-x.dec.com";
       $tz{'Mountain'}->{'s1i'}     = "204.123.2.72";
       $tz{'Mountain'}->{'s2n'}     = "navobs1.usnogps.navy.mil";
       $tz{'Mountain'}->{'s2i'}     = "204.34.198.40";
       $tz{'Mountain'}->{'s3n'}     = "utcnist.colorado.edu";
       $tz{'Mountain'}->{'s3i'}     = "128.138.140.44";

    $tz{'West'}->{'name'}       = "/usr/share/zoneinfo/America/Los_Angeles";
       $tz{'West'}->{'s1n'}     = "gpstime.trimble.com";
       $tz{'West'}->{'s1i'}     = "206.40.88.30";
       $tz{'West'}->{'s2n'}     = "ntp-cup.external.hp.com";
       $tz{'West'}->{'s2i'}     = "192.6.38.127";
       $tz{'West'}->{'s3n'}     = "ns.scruz.net";
       $tz{'West'}->{'s3i'}     = "165.227.1.1";


    ### So now we know what file we want to copy.  Just Do It (tm).
    $tzfile = $tz{$timezone}->{'name'};

    if (-e "/etc/localtime") { unlink "/etc/localtime"; }
    system "ln -s $tzfile /etc/localtime";


    ### ##################################################################
    ### Now the fun begins.  This code come straight from the time module.
    ### I was too lazy to do a remote call so I just copied it... oh well.
    ### ##################################################################

    ### /etc/ntp.conf
    ### Read into @conf;
    &obtain_lock("/etc/ntp.conf");
    open CONF, "/etc/ntp.conf";
      while (<CONF>) { chomp $_; if ($_ !~ m/^server/) { push @conf, $_; } }
    close CONF;

    ### Write it back, with our servers on the top.
    open CONF, ">/etc/ntp.conf";
      print CONF "server $tz{$timezone}->{'s1n'}\n";
      print CONF "server $tz{$timezone}->{'s2n'}\n";
      print CONF "server $tz{$timezone}->{'s3n'}\n\n";
      foreach (@conf) { print CONF "$_\n"; }
    close CONF;
    &release_lock("/etc/ntp.conf");

    ### /etc/ntp/step-tickers
    ### Just re-write the file from scratch, since this is all that is in there.
    &obtain_lock("/etc/ntp/step-tickers");
    open TICKERS, ">/etc/ntp/step-tickers";
      print TICKERS "$tz{$timezone}->{'s1i'}\n";
      print TICKERS "$tz{$timezone}->{'s2i'}\n";
      print TICKERS "$tz{$timezone}->{'s3i'}\n";
    close TICKERS;
    &release_lock("/etc/ntp/step-tickers");

    ### Sanitize file permissions.
    chmod 0600, "/etc/ntp/step-tickers";
    chmod 0640, "/etc/ntp.conf";
  } 


  ### Whisk me away to a magical place...
  &redirect("step7.cgi");
  exit;
